// Constants
var emptyString = "";
var delimiter = ".";
var frameDuration = 100; // at 10 frames/sec: each Frame = 100 ms.
var unit = 100;
var horUnit = unit*.8;
var textHeight = 36;
var indent = 65;
var started = new Boolean(false);
var currentItem = new Array();

var iconSize = 90;
var screenHeight = 1024;
var screenWidth = 768;

// Integer Object
function Integer(value) { this.int = value; }
function Integer.prototype.set(value) { this.int = value; }
function Integer.prototype.value() { return this.int; }
function Integer.prototype.toString() { return String(this.int); }

// Dictionary Object
function Dictionary(key, value) { eval("this."+ key +"=value"); }
function Dictionary.prototype.valueForKey(key, value) { eval("this."+ key +"=value"); }

// Coordinate Object
function Coordinate(x,y) { this.x = x; this.y = y; }
function Coordinate.prototype.getX() { return this.x; }
function Coordinate.prototype.getY() { return this.y; }
function Coordinate.prototype.toString() { return this.x +", "+ this.y; }

// Dimensions Object
function Dimensions(width,height) { this.width = width; this.height = height; }
function Dimensions.prototype.getWidth() { return this.width; }
function Dimensions.prototype.getHeight() { return this.height; }

// IconCache Object
function IconCache(obj) {
	this.dim = new Dimensions(getVal(obj,"width"),getVal(obj,"height"));
	this.pos = new Coordinate(getVal(obj,"x"),getVal(obj,"y"));
	this.icon = obj;
}
function IconCache.prototype.getDim() { return this.dim; }
function IconCache.prototype.getPos() { return this.pos; }
function IconCache.prototype.getX() { return this.pos.x; }
function IconCache.prototype.getY() { return this.pos.y; }
function IconCache.prototype.getWidth() { return this.dim.width; }
function IconCache.prototype.getHeight() { return this.dim.height; }
function IconCache.prototype.empty() { this.dim = null; this.pos = null; }
function IconCache.prototype.toString() { return "IconCache: x="+ this.getX() +"; y="+ this.getY() +"; width="+ this.getWidth() +"; height="+ this.getHeight(); }
function clearIconCache(ic) { ic.empty(); ic = null; }

// AniTracker Object
function AniTracker(arg) { // Constructor
	if(isAni(arg)) this.aos = new Array(ao);
	else { this.aos = new Array(); }
	this.active = new Boolean(false);
}
function AniTracker.prototype.add(arg) {
	if(isAni(arg)) this.aos.push(arg);
	else if (isArray(arg)) for(var i=0;i<=arg.length;i++) this.aos.push(arg[i]);
}
function AniTracker.prototype.ao(pos) { return this.aos[pos]; }
function AniTracker.prototype.isActive() { return this.active; }
function AniTracker.prototype.isIdle() { return (this.active == false); }
function AniTracker.prototype.getLength() { return this.aos.length; }
function AniTracker.prototype.toString() { return this.aos.toString(); }
function AniTracker.prototype.empty() { this.aos = new Array(); }
function AniTracker.prototype.cleanUp() {
	var newArray = new Array();
	for(var i=0;i<this.getLength();i++) if(this.aos[i] != null) newArray.push(this.aos[i]);
	this.aos = newArray;
}
function AniTracker.prototype.track() {
	var removeArray;
	for(var i=0;i<this.getLength();i++) {
		var ao = this.ao(i);
		if(isAni(ao)) {
			var currentValue = parseFloat(getVal(ao.object,ao.attribute));
			ao.timeRemaining = ao.timeRemaining - frameDuration;
			if(ao.timeRemaining > 0) {
				try { ao.object.setAttribute(ao.attribute, currentValue + parseFloat(ao.step)); }
				catch(e) { status = "Error: Could not set attribute. Probably no Object."; }
			}
			else {
				if (removeArray != null) removeArray.push(new Integer(i));
				else { removeArray = new Array(new Integer(i)); }
				if(ao.remove()) ao = null;
			}
		}
	}
	if(removeArray!=null) {
		for (var i=0;i<removeArray.length;i++) { this.aos[removeArray[i].value()] = null; }
		removeArray = null;
		this.cleanUp();
	}
	if(this.getLength()>0) {
		this.active = true;
		setTimeout("at.track()", frameDuration);
	}
	else {
		this.active = false;
		this.empty();
	}
}
// End AniTracker Object

// Utility Functions
function isArray(obj) { return (obj.constructor.toString().indexOf("Array")!=-1)?true:false; }
function arrayStr(anArray) {
	var l = anArray.length;
	if(l>1) {
		var str = anArray[0];
		for(var i=1;i<anArray.length;i++) str += " und "+ anArray[i];
		return str;
	}
	else if(l>0) return anArray[0];
	else return emptyString;
}
function arrayCopy(anArray) {
	var newArray = new Array(anArray.length);
	for(var i=0;i<anArray.length;i++) newArray[i] = anArray[i];
	return newArray;
}
function array(nodeCollection) {
	var newArray = new Array(nodeCollection.length);
	for(var i=0;i<nodeCollection.length;i++) newArray[i] = nodeCollection.item(i);
	return newArray;
}
function isInteger(val){ for(var i=0;i<val.length;i++) if(!isDigit(val.charAt(i))) return false; return true; }
function setText(obj,str) { obj.appendChild(document.createTextNode(str)); }
function startsWith(str,searchExpr) { if(str.indexOf(searchExpr)==0) return true; return false; }
function packString(str) {
	var end = str.length-1;
	while(str.charCodeAt(end)==32) end--;
	return str.substring(0,end);
}
function getObj(name) { return document.getElementById(name); }
function getVal(obj,attrib) {
	try {
		var value = obj.getAttribute(attrib);
		if ( value==null || value==emptyString ) { value = getDefaultValue(attrib); }
	}
	catch (e) { 
		status = "Error: Could not get Attribute. Probably no Object available.";
		return 0;
	}
	return value;
}
function getDefaultValue(attrib) {
	switch(attrib) {
		case "opacity":		return 1;		break;
		case "visibility":	return "visible";	break;
		case "filter":		return null;		break;
		default:		return 0;		break;
	}
}

// AniObject
function AniObject(obj,attrib,value,dur) { // Animation Object
	var duration = dur * 1000;
	var steps = duration / frameDuration;
	var currentValue = getVal(obj,attrib);
	// Set Member properties
	this.type = "AniObject";
	this.object = obj;
	this.attribute = attrib;
	this.targetValue = value;
	this.timeRemaining = dur * 1000; // Milliseconds.
	this.step = (value - currentValue) / steps;
}
function AniObject.prototype.toString() { return this.type +": Object="+ this.object
	+"; Attribute="+ this.attribute +"; TargetValue="+ this.targetValue
	+"; TimeRemaining="+ this.timeRemaining +"; Step="+ this.step;
}
function AniObject.prototype.remove() {
	if ((this.attribute == "opacity")&&(this.targetValue==0)) {
		remove(this.object);
		return true;
	}
	return false;
}
function isAni(ao) {
	try { if (ao != null) if (ao.type == "AniObject") return true; }
	catch (e) { return false; }
	return false;
}
// AniObject Extensions
function fadeOut(obj,dur) { return new AniObject(obj,"opacity",0,dur); }
function fadeIn(obj,dur) { return new AniObject(obj,"opacity",1,dur); }
// End AniObject

// Singular Animation Functions
function advance(ao) { // Using a single JavaScript TimeOut
	if(ao.type=="AniObject") {
		var currentValue = parseFloat(getVal(ao.object,ao.attribute));
		ao.timeRemaining = ao.timeRemaining - frameDuration;
		if(ao.timeRemaining > 0) {
			try { ao.object.setAttribute(ao.attribute, currentValue + parseFloat(ao.step)); }
			catch(e) { status = "Error: Could not set attribute. Probably no Object."; }
			setTimeout("advance(ao)", frameDuration);
		}
		else { if(ao.remove()) ao = null; }
	}
}
function animate(ao) { // Appending an Animation Element
	if(ao.type=="AniObject") {
		var anim = document.createElement("animate"); // Creat Anim. Tag
		anim.setAttribute("attributeName",ao.attribute);
		anim.setAttribute("begin",0);
		anim.setAttribute("dur",eval(ao.timeRemaining/1000));
		anim.setAttribute("from",getVal(ao.object,ao.attribute));
		anim.setAttribute("to",ao.targetValue);
		anim.setAttribute("fill","freeze");
		ao.object.appendChild(anim);
		ao = null;
	}
}

// Layout Functions
function scale(obj,factor,dur) {
	var oldWidth = getVal(obj,"width");
	var oldHeight = getVal(obj,"height");
	var newX = getVal(obj,"x") - (oldWidth*(factor-1))/2;
	var newY = getVal(obj,"y") - (oldHeight*(factor-1))/2;
	var xAni = new AniObject(obj,"x",newX,dur);
	var yAni = new AniObject(obj,"y",newY,dur);
	var widthAni = new AniObject(obj,"width",oldWidth*factor,dur);
	var heightAni = new AniObject(obj,"height",oldHeight*factor,dur);
	at.add(new Array(xAni, yAni, widthAni, heightAni));
	if(at.isIdle()) at.track();
}
function scaleTo(obj,dim,pos,dur) {
	var xAni = new AniObject(obj,"x",pos.getX(),dur);
	var yAni = new AniObject(obj,"y",pos.getY(),dur);
	var widthAni = new AniObject(obj,"width",dim.getWidth(),dur);
	var heightAni = new AniObject(obj,"height",dim.getHeight(),dur);
	at.add(new Array(xAni, yAni, widthAni, heightAni));
	if(at.isIdle()) at.track();
}
// Zoom Functions. Need IconCache (ic)
function zoomIn() {
	var icon = evt.getTarget();
	var duration = 0.25;
	var factor = 1.25;
	ic = new IconCache(icon);
	scale(icon,factor,duration);
	setTimeout("scale(ic.icon,"+ eval(1/factor) +","+ duration +")", duration*1000);
}
function zoomOut() {
	var icon = evt.getTarget();
	scaleTo(icon,ic.dim,ic.pos,0.3);
}
function center(obj,coord) {
	try {
		var width = obj.getAttribute("width");
		var height = obj.getAttribute("height");
		obj.setAttribute("x",coord.getX()-width/2);
		obj.setAttribute("y",coord.getY()-height/2);
	}
	catch (e) { status = "Error: Could not place Object. (Probably not available)"; }
}
function place(obj,coord) {
	try {
		obj.setAttribute("x",coord.getX());
		obj.setAttribute("y",coord.getY());
	}
	catch (e) { status = "Error: Could not place Object. (Probably not available)"; }
}
function hide(obj) {
	try { obj.setAttribute("visibility","hidden"); }
	catch (e) { status = "Error: Could not hide Object. (Probably not available)"; }
}
function show(obj) {
	try { obj.setAttribute("visibility","visible"); }
	catch (e) { status = "Error: Could not show Object. (Probably not available)"; }
}
function remove(obj) {
	try {
		var parent = obj.getParentNode();
		parent.removeChild(obj);
	}
	catch (e) { status = "Error: Could not remove Object."; }
}

// Graphic functions

function select(targetObject) {
	var g; // Folder Group to highlight
	if(arguments.length>0) g = targetObject;
	else {
		deSelect(document.getElementById(currentItem.join(delimiter)));	
		g = evt.getTarget().parentNode;
	}
	var grad = g.firstChild;
	var text = grad.nextSibling.nextSibling;
	text.setAttribute("class","white");
	grad.setAttribute("visibility","visible");
	var gradFade = fadeIn(grad,0.5)
	at.add(gradFade); // Animate Gradient Fade-In
	if(at.isIdle()) at.track();
	// Set Current Item to selected Object
	currentItem = String(getVal(g,"id")).split(delimiter);
}
function deSelect(targetObject) {
	var g; // Folder Group to deselect
	if(arguments.length>0) g = targetObject;
	else g = evt.getTarget().parentNode;
	var grad = g.firstChild;
	var text = grad.nextSibling.nextSibling;
	text.setAttribute("class","black");
	grad.setAttribute("visibility","hidden");
	grad.setAttribute("opacity",0);
}
function hoverPlus() {
	var plus, id, flag;
	if(arguments.length>1) {
		id = arguments[0];
		flag = arguments[1];
		plus = document.getElementById(id);
	}
	else {
		flag = arguments[0];
		plus = evt.getTarget().parentNode;
		id = getVal(plus,"id");
	}
	var idArray = String(id).split(delimiter);
	idArray.shift(); // Remove "plus";
	var folder = document.getElementById(id);
	var item = p.getItemByArray(idArray);
	var kids = plus.childNodes;
	var index = kids.length - 1;
	if(flag) {
		if(item.expanded) kids.item(index).setAttribute("visibility","visible");
		else kids.item(index).setAttribute("visibility","hidden");
	}
	else {
		if(item.expanded) kids.item(index).setAttribute("visibility","hidden");
		else kids.item(index).setAttribute("visibility","visible");
	}
}
function validId(id) {
	if(id == null) return false;
	else if(id == emptyString) return false;
	else if(!isArray(id)) return false;
	else if(!id.length>0) return false;
	else for(var i=0;i<id.length;i++) if(!parseInt(id[i])>0) return false;
	return true;
}
function filter(groups,id,expand) {
	var ret = new Array();
	var mId = String(id).split(delimiter);
	// Check for each group element
	for(var i=0;i<groups.length;i++) {
		var group = groups.item(i);
		var gId = String(getVal(group,"id")).split(delimiter);
		if (gId[0]=="plus"||gId[0]=="hline"||gId[0]=="vline"||gId[0]=="image"||gId[0]=="text")
			gId.shift();	// Also take into account the abovementioned items
		if(!validId(gId)) continue;
		var match = null;
		var index = -1;
		while(match == null) {
			index++;
			var myId = mId[index];
			if(myId == null) match = false;
			var grId = gId[index];
			if(grId == null) match = false;
			if(expand && match==null) {
				if(grId>myId) match = true;
				else if(grId<myId)match =false;
			}
			else if(!expand && match==null) {
				if(myId>grId) match = true;
				else if(myId<grId) match = true;
			}
		}
		if(match) ret.push(group);
	}
	return ret;
}
function move(groups,amount,down) {
	for(var i=0;i<groups.length;i++) {
		var g = groups[i];
		for(var j=0;j<g.childNodes.length;j++) {
			var elem = g.childNodes.item(j);
			var thisY = parseInt(getVal(elem,"y"));
			if(thisY>0) {
				if(down) elem.setAttribute("y",eval(thisY+amount));
				else elem.setAttribute("y",eval(thisY-amount));
			}
		}
	}
}
function modifyLine(id,amount) {
	var idArray = id.split(delimiter);
	while(idArray.length>1) {
		var oldArr = String(idArray.toString());
		var currentItem = idArray.pop();
		var itemsInLayer = p.getItemByArray(idArray).items.length;
		if(currentItem<itemsInLayer) {
			id = idArray.join(delimiter);
			var line = document.getElementById("vline."+ id).firstChild;
			var height = parseInt(getVal(line,"height"));
			line.setAttribute("height",eval(height+amount));
		}
	}
}
function textObj(str) {
	var to = document.createElement("text");
	to.setAttribute("class","black");
	to.setAttribute("alignment-baseline","middle");
	to.setAttribute("width","100%");
	to.appendChild(document.createTextNode(str));
	return to;
}
function setActions(obj) {
	obj.setAttribute("onmouseover","select()");
	// obj.setAttribute("onmouseout","deSelect()");
	obj.setAttribute("onclick","expand()");
}
function setPlusActions(obj,id) {
	obj.setAttribute("onmouseover","hoverPlus(true)");
	obj.setAttribute("onmouseout","hoverPlus(false)");
	obj.setAttribute("onclick","expand()");
}
function gradient(x,y,height) {
	var grad = document.createElement("rect");
	grad.setAttribute("opacity",0); // Default: transparent
	grad.setAttribute("visibility","hidden"); //... and invisible
	grad.setAttribute("x",x);
	grad.setAttribute("y",y);
	grad.setAttribute("height",height);
	grad.setAttribute("width",screenWidth-x);
	grad.setAttribute("fill","url(#linearGradient)");
	return grad;
}
function plus(x,y,id) {
	var size = 10; // Radius
	var pSize = size/3;
	var plus = document.createElement("g");
	plus.setAttribute("id","plus."+ id);
	var square = document.createElement("rect");
	square.setAttribute("x",x-size/2);
	square.setAttribute("y",y-size/2);
	square.setAttribute("width",size);
	square.setAttribute("height",size);
	square.setAttribute("class","plus");
	setPlusActions(square,id);
	plus.appendChild(square);
	var horiz = document.createElement("rect");
	horiz.setAttribute("x",x-pSize);
	horiz.setAttribute("y",y);
	horiz.setAttribute("width",2*pSize);
	horiz.setAttribute("height",0);
	horiz.setAttribute("class","pl");
	setPlusActions(horiz,id);
	plus.appendChild(horiz);
	var vert = document.createElement("rect");
	vert.setAttribute("x",x);
	vert.setAttribute("y",y-pSize);
	vert.setAttribute("width",0);
	vert.setAttribute("height",2*pSize);
	vert.setAttribute("class","pl");
	setPlusActions(vert,id);
	plus.appendChild(vert);
	return plus;
}
function hLine(x,y,length,id) {
	var g = document.createElement("g");
	g.setAttribute("id","hline."+ id);
	var l = document.createElement("rect");
	l.setAttribute("x",x);
	l.setAttribute("y",y);
	l.setAttribute("width",length);
	l.setAttribute("height",2);
	l.setAttribute("fill","url(#chessboard)");
	g.appendChild(l);
	return g;
}
function vLine(x,y,length,id) {
	var g = document.createElement("g");
	g.setAttribute("id","vline."+ id);
	var l = document.createElement("rect");
	l.setAttribute("x",x);
	l.setAttribute("y",y);
	l.setAttribute("width",2);
	l.setAttribute("height",length);
	l.setAttribute("fill","url(#chessboard)");
	g.appendChild(l);
	return g;
}
function frame(x,y,width,height,id) {
	var f = document.createElement("rect");
	f.setAttribute("id","frame."+ id);
	f.setAttribute("x",x);
	f.setAttribute("y",y);
	f.setAttribute("width",width);
	f.setAttribute("height",height);
	f.setAttribute("class","frame");
	return f;
}
function textField(x,y,size) {
	var t = document.createElement("text");
	t.setAttribute("x",x);
	t.setAttribute("y",y);
	t.setAttribute("style","font-size:"+ size +"px");
	return t;
}
function textArea(x,y,width,text,id) {
	var fontSize = 28;
	var offset = 10;
	var max = width - offset; // Max Width
	var textArray = text.split(" ");
	var g = document.createElement("g");
	g.setAttribute("id","text."+ id);
	var f = frame(x,y,width,0,id);
	g.appendChild(f);
	var t = textField(x+offset,y+fontSize,fontSize);
	t.appendChild(document.createTextNode(textArray.shift()));
	var length = textArray.length;
	for(var i=0;i<length;i++) {
		var lastWord = textArray.shift();
		t.firstChild.appendData(" "+ lastWord);
		if(t.getComputedTextLength()>max) {
			t.firstChild.deleteData(t.firstChild.nodeValue.length-lastWord.length,lastWord.length);
			g.appendChild(t);
			y += fontSize;
			t = textField(x+offset,y+fontSize,fontSize);
			t.appendChild(document.createTextNode(lastWord));
		}
	}
	g.appendChild(t);
	f.setAttribute("height",y-parseInt(getVal(f,"y"))+fontSize+offset)
	f.setAttribute("onclick","collapse()");
	return g;
}
function image(x,y,width,height,symbId,id) {
	var g = document.createElement("g");
	g.setAttribute("id","image."+ id);
	var f = frame(x,y,width,height,id);
	g.appendChild(f);
	var symbol = document.getElementById(symbId);
	var img = symbol.cloneNode(false);
	img.setAttribute("x",x);
	img.setAttribute("y",y);
	img.setAttribute("width",width);
	img.setAttribute("height",height);
	img.setAttribute("onclick","collapse()");
	g.appendChild(img);
	return g;
}
function folder(x,y,id,item) {
	var g = document.createElement("g"); // Group
	g.setAttribute("id",id);
	var grad = gradient(x+20,y-.9*textHeight,1.2*textHeight);
	setActions(grad);
	g.appendChild(grad);
	var icon = getObj(item.icon).cloneNode(false);
	center(icon, new Coordinate(x,y));
	show(icon);
	setActions(icon);
	g.appendChild(icon);
	var text = textObj(item.name);
	place(text, new Coordinate(x+indent,y));
	show(text);
	setActions(text);
	g.appendChild(text);
	return g;
}


/******* XML Representation ********/


function Created() {
	this.date = new Date();
	this.format = "dd.mm.yyyyy"; // Europen Date Format
}
function Created.prototype.setDate(date) { // Date as mmddyyyy String
	var dateElements = date.split(delimiter);
	this.date.setDate(parseInt(dateElements[0]));
	this.date.setMonth(parseInt(dateElements[1])-1)
	this.date.setFullYear(parseInt(dateElements[2]));
	// Set the Clock to Zero...
	this.date.setHours(0);
	this.date.setMinutes(0);
	this.date.setMilliseconds(0);
}
function Created.prototype.toString() { return this.date.getDate() +"."+  eval(this.date.getMonth()+1) +"."+  this.date.getFullYear(); }
function Head(aTitle) {
	this.title = aTitle;
	this.authors = new Array();
	this.date = new Created();
}
function Head.prototype.addAuthor(anAuthor) { this.authors.push(anAuthor); }
function Head.prototype.defineSetting(aSetting) { this.setting = aSetting; }
function Head.prototype.setDesc(aText) { this.desc = aText; }
function Head.prototype.setDate(date) { this.date.setDate(date); }
function Head.prototype.toString() {
	return "Title: "+ this.title +"\nAuthors: "+ this.authors
	+"Setting: "+ this.setting +" Date: "+ this.date +"\nDescription: "+ this.desc;
}
function Body() { this.items = new Array(); }
function Body.prototype.toString() { return this.items.toString(); }
function Img(address) {
	this.src = address;
	this.image = new Image();
	this.image.src = address;
	this.width = this.image.width;
	this.height = this.image.height;
}
function Img.prototype.setId(arg) { this.id = arg; }
function Img.prototype.setWidth(arg) { this.width = arg; }
function Img.prototype.setHeight(arg) { this.height = arg; }
function Img.prototype.toString() {
	return "Image: "+ this.src +"\nID: "+ this.id
	+" width: "+ this.width +" height: "+ this.height; }
function Item(aName) {
	this.name = aName;
	this.icon = "default";
	this.items = new Array();
	this.expanded = false;
}
function Item.prototype.setId(anId) { this.id = anId; }
function Item.prototype.setIcon(anIcon) { this.icon = anIcon; }
function Item.prototype.setText(aText) { this.text = aText; }
function Item.prototype.setImage(anImage) { this.image = anImage; }
function Item.prototype.addItem(anItem) { this.items.push(anItem); }
function Item.prototype.hasContent() { return (this.image!=null)||(this.text!=null); }
function Item.prototype.toString() {
	return "Item: "+ this.name +"\nID: "+ this.id +" icon: "+ this.icon
	+ "text: "+ this.text +" image: "+ this.image +" items: " + this.items; }
function hasMoreItems(idArray) {
	var ids = arrayCopy(idArray);
	if(ids.length>1) {
		var item = ids.pop();
		var parentItem = p.getItemByArray(ids);
		return (parentItem.items.length>item);
	}
	else if(ids.length==1) return (p.items.length>ids[0]);
	else return false;
}
function Presentation(aTitle) {
	this.head = new Head(aTitle);
	this.body = new Body();
}
function Presentation.prototype.addItem(anItem) { this.body.items.push(anItem); }
function Presentation.prototype.getItemByArray(idArray) {
	var ret = this.body;
	for(var i=0;i<idArray.length;i++) ret = ret.items[idArray[i]-1];
	return ret;
}
function Presentation.prototype.item(i) { return this.body.items[i]; }
function Presentation.prototype.toString() { return this.head + this.body; }
	
/******* XML Parsing Stuff *********/

function ns(arg) { return "pd:"+ arg; } // NameSpace Adder
function Node(aNode) { this.node = aNode; }
function Node.prototype.count() { return 1; }
function Node.prototype.isText() { return (this.node.nodeType==3);  }
function Node.prototype.text() { return this.node.firstChild.nodeValue; }
function Node.prototype.filter(criterion) {
	var nodes = new Nodes();
	var kids = this.node.childNodes;
	for(var i=0;i<kids.length;i++) {
		var item = kids.item(i)
		if(item.nodeName==criterion) { nodes.add(new Node(item)); }
	}
	if(nodes.count()>1) return nodes;
	else { 
		if(nodes.count()==1) return nodes.pop();
		if(nodes.count()<1) return new Nodes();
	}
}
function Node.prototype.toString() { return this.node.nodeName +": "+ this.node.nodeValue; }
function Node.prototype.parseImage(receiver) {
	var address = this.node.getAttribute("xlink:href");
	var img = new Img(address);
	var id = this.node.getAttribute("id");
	var width = this.node.getAttribute("width");
	var height = this.node.getAttribute("height");
	if(id!=emptyString) img.setId(id);
	if(width!=emptyString && img.width==null) img.setWidth(width);
	if(height!=emptyString && img.height==null) img.setHeight(height);
	receiver.setImage(img);
}
function Node.prototype.parse(receiver) { // Item
	var item;
	var title = this.text();
	if(title.charCodeAt(title.length-1)==32) title = packString(title); // Line Break Fix
	item = new Item(title); // Instantiate with Title
	if(this.node.attributes.length>0) { // has Attributes
		var id = this.node.getAttribute("id");
		var icon = this.node.getAttribute("icon");
		if(id!=emptyString) item.setId(id);
		if(icon!=emptyString) item.setIcon(icon);
	}
	if(this.node.childNodes.length>1) { // has items
		var image = this.filter("image");
		if(image.count()==1) { image.parseImage(item); }
		var text = this.filter(ns("text"));
		if(text.count()==1) { item.setText(text.text()); }
		var items = this.filter(ns("item"));
		if(items.count()>0) { // Recursion
			if(items.count()==1) items.parse(item);
			else for(var i=0;i<items.count();i++) items.node(i).parse(item);
		}
	}
	receiver.addItem(item);
}
// Nodes
function Nodes() { this.nodes = new Array(); }
function Nodes.prototype.node(i) { return this.nodes[i]; }
function Nodes.prototype.add(node) { this.nodes.push(node); }
function Nodes.prototype.length() { return this.nodes.length; }
function Nodes.prototype.toString() { return this.nodes.toString(); }
function Nodes.prototype.count() { return this.nodes.length; }
function Nodes.prototype.pop() { return this.nodes.pop(); }
function Nodes.prototype.parse(receiver) { for(var i=0;i<this.length();i++) this.node(i).parse(receiver); }

/******* Expand / Collapse *********/

function expand() {
	var parent; // Parent Folder to expand
	if(arguments.length>0) parent = arguments[0];
	else parent = evt.getTarget().parentNode;
	var parentId = String(getVal(parent,"id"));
	var idArray = parentId.split(delimiter);
	var first = idArray[0];
	if(isNaN(first)) {
		if(first=="plus"||first=="image"||first=="text") {
			idArray.shift(); // Remove text crap from parentId
			parentId = idArray.join(delimiter);
			parent = document.getElementById(parentId);
		}
		else return; // Trying to expand non-existing subtree		
	}
	var it = p.getItemByArray(idArray);
	var subItems = it.items.length;
	if(!it.expanded) {
		var x = idArray.length * horUnit;
		var y = parseInt(getVal(parent.lastChild,"y"));
		var allGroups = document.getElementsByTagName("g");
		var translY = document.rootElement.currentTranslate.y;
		var selection = filter(allGroups,parentId,true);
		if(subItems>0) {
			move(selection,subItems*unit,true); // Lower Items coming after it
			if(parentId.indexOf(delimiter)>0) modifyLine(parentId,unit*subItems);
			if(y+subItems*unit+translY+unit>screenHeight||y+translY<unit) document.rootElement.currentTranslate.y = unit-y;
			// Draw SubItems
			parent.parentNode.insertBefore(vLine(x,y,unit*subItems,parentId),parent);
			for(var i=0;i<subItems;i++) {
				var index = i + 1;
				var id = parentId + delimiter + index;
				parent.appendChild(hLine(x,y+unit*index,horUnit,id));
				parent.appendChild(folder(x+horUnit,y+unit*index,id,it.items[i]));
				if(it.items[i].items.length>0 || it.items[i].hasContent())
					parent.appendChild(plus(x,y+unit*index,id));
			}
		}
		else if(it.hasContent()) {
			var xOffset = 20;
			var yOffset = 30;
			if(it.text!=null) {
				var width = screenWidth - x - xOffset - indent;
				var ta = textArea(x+indent,y+yOffset,width,it.text,parentId);
				var height = parseInt(getVal(ta.firstChild,"height"));
				// Lower Items coming after it...
				move(selection,height,true); 
				if(parentId.indexOf(delimiter)>0) modifyLine(parentId,height);
				if(y+height+translY>screenHeight||y+translY<unit) document.rootElement.currentTranslate.y = unit-y;
				parent.appendChild(ta);
			}
			else {	// Image - Calculations
				x -= iconSize / 2;
				it.image.image.width = it.image.width;
				it.image.image.height = it.image.height;
				var aspectRatio = it.image.width / it.image.height;
				it.image.width = screenWidth - x - xOffset;
				it.image.height = it.image.width / aspectRatio;
				// Lower Items coming after it...
				move(selection,it.image.height,true); 
				if(parentId.indexOf(delimiter)>0) modifyLine(parentId,it.image.height);
				if(y+it.image.height+translY>screenHeight||y+translY<unit/2) document.rootElement.currentTranslate.y = unit/2-y;
				// Actual Drawing Stuff:...
				parent.appendChild(image(x,y+yOffset,it.image.width,it.image.height,it.image.id,parentId));
			}
		}
		else return;
		// For Both (Content and SubItems): set expanded flag in array structure
		it.expanded = true;
		currentItem = idArray;
		if(idArray.length>1) hoverPlus("plus."+ parentId,false); // Change Plus + > -
	}
	else collapse(idArray,it);
}
function collapse(idArray,item) {
	if(!arguments.length>0) { // Call through Image or Text Content
		var targetId = getVal(evt.getTarget().parentNode,"id");
		var idArray = targetId.split(delimiter);
		if(idArray.length>0) if(isNaN(idArray[0])) idArray.shift();
		item = p.getItemByArray(idArray);
	}
	var id = idArray.join(delimiter);
	var subItems = item.items.length;
	for (var i=0;i<subItems;i++) {
		if(item.items[i].expanded) {
			var subArray = arrayCopy(idArray);
			subArray.push(i+1);
			collapse(subArray,item.items[i]);
		}
	}
	var group = document.getElementById(id);
	var parent = group.parentNode;
	var vLine = document.getElementById("vline."+ id);
	if(item.text!= null) var height = parseInt(getVal(group.lastChild.firstChild,"height"));
	if(vLine != null) parent.removeChild(vLine);
	var abort = false; // Cancelling criterion for loop
	while(!abort) {
		lastKid = group.lastChild;
		if(getVal(lastKid,"id")!=0) group.removeChild(lastKid);
		else abort = true; 
	}
	var allGroups = document.getElementsByTagName("g");
	var selection = filter(allGroups,id,true);
	if(subItems>0) {
		move(selection,subItems*unit,false);
		modifyLine(id,unit*subItems*(-1));
	}
	else if(item.hasContent()) {
		if(item.image!= null) {
			move(selection,item.image.height,false);
			modifyLine(id,item.image.height*(-1));
		}
		else if(item.text!= null){
			move(selection,height,false);
			modifyLine(id,height*(-1));
		}
	}
	// Re-Center item
	var y = parseInt(getVal(group.lastChild,"y"));
	document.rootElement.currentTranslate.y = screenHeight/2-y;
	// Reset expanded flag in array structure
	item.expanded = false;
	if(idArray.length>1) hoverPlus("plus."+ id,false); // Change Plus - > +	
	currentItem = idArray;
}

function nextItem() {
	var idArray = arrayCopy(currentItem);
	var item = p.getItemByArray(idArray);
	var id = idArray.join(delimiter);
	var folder = document.getElementById(id);
	deSelect(folder);
	if(item.items.length>0||(item.hasContent()&&!item.expanded)) { // has subItems -> go deeper
		if(!item.expanded) expand(folder);
		if(!item.hasContent()) idArray.push(1);
	} // Else: No subItems -> go to next item
	else {
		while(idArray.length>1) {
			if(hasMoreItems(idArray)) {
				if(item.hasContent()) collapse(idArray,item);
				idArray[idArray.length-1]++;
				break;
			} // Else: Check for next item in above hierarchy
			else {
				idArray.pop();
				var item = p.getItemByArray(idArray);
				collapse(idArray,item);
			}
		}
	}
	id = idArray.join(delimiter);
	folder = document.getElementById(id);
	currentItem = arrayCopy(idArray);
	select(folder);
}

/******* Member Variables *********/

var at = new AniTracker(); // Empty AniTracker (or the at.track - TimeOut >> Need global AniTracker member)
var ic = new IconCache();

/************ StartUp ************/

if (window.innerHeight != null) { // Get Window Size.
	var screenHeight = window.innerHeight;
	var screenWidth = window.innerWidth;
}
var root = getObj("contentArea"); // Root Element
var listener = new AntiZoomAndPan();
listener.appendNode(document.getElementById("background"));

// Parse XML Data

var presentation = new Node(document.getElementById("pdata"));
var head = presentation.filter(ns("head")); // Parse Head
var p = new Presentation(head.filter(ns("title")).text());
var authors = head.filter(ns("author"));
if(authors.count()!=1) for(var i=0;i<authors.count();i++) p.head.addAuthor(authors.node(i).text());
else p.head.addAuthor(authors.text());
p.head.defineSetting(head.filter(ns("setting")).text());
p.head.setDate(head.filter(ns("date")).text());
p.head.setDesc(head.filter(ns("desc")).text()); // Parse Body
var body = presentation.filter(ns("body"));
var items = body.filter(ns("item"));
items.parse(p);

// Assign Header Data to Start Slide
setText(getObj("title"),p.head.title);
setText(getObj("authors"),arrayStr(p.head.authors));
setText(getObj("desc"),p.head.desc);
setText(getObj("timeDate"),p.head.setting +", "+ p.head.date);

// Place Start Icon
var startIcon = getObj("startIcon");
var startIconWidth, startIconHeight;
try {
	startIconWidth = startIcon.getAttribute("width");
	startIconHeight = startIcon.getAttribute("height");
}
catch (e) {
	startIconWidth = iconSize;
	startIconHeight = iconSize;
	status = "Error: Could not determine Start Icon Sizes";
}
center(startIcon, new Coordinate(screenWidth/2,screenHeight/2));
show(startIcon);
at.add(fadeIn(startIcon,1));
if(at.isIdle()) at.track();

// Wait for click...
function start() {
	if(started == false) {
		started = true;
		var fadeIcon = fadeOut(evt.getTarget(),4);
		var fadeAuthors = fadeOut(getObj("authors"),1);
		var fadeTitle = fadeOut(getObj("titleArea"),0.3);
		var fadeText = fadeOut(getObj("texts"),2);
		at.add(new Array(fadeIcon,fadeAuthors,fadeTitle,fadeText));
		if(at.isIdle()) at.track();
		setTimeout("startShow()",5000);
	}
}
// Let the Show begin..

function startShow() {
	var startIndex = 1; // Start at Top Level (1)
	currentItem.push(startIndex);
	var rootFolder = folder(startIndex*unit,startIndex*unit,String(startIndex),p.body.items[startIndex-1]);
	rootFolder.setAttribute("opacity",0);
	root.appendChild(rootFolder);
	at.add(fadeIn(rootFolder,1)); // Fade in...
	if(at.isIdle()) at.track();
	document.getElementById("background").setAttribute("onclick","nextItem()"); // Set listener for Clicks
}